<?
class SQLTableVersion extends BaseObject {

 var $table = "";
 var $jointable = "";
 var $jointablecol = "";
 var $joincol = "";
 var $where = "";

 function SQLTableVersion() {
 parent::BaseObject();
 }

 function setTable($table) {
 $this->table = $table;
 }

 function setJoin($jointable,$jointablecol,$joincol) {
 $this->jointable = $jointable;
 $this->jointablecol = $jointablecol;
 $this->joincol = $joincol;
 }

 function setWhere($where) {
 if ($where == "") $where = "1=1";
 $this->where = $where;
 }

 function diffVersion($time,$user) {
 return createVersion($time,$user,true);
 }

 function createVersion($time,$user,$fake = false) {
 
 $tablecols = $this->getVersionedColumns();
 $this->table = sqlf_table($this->table);
 if ($this->hasJoinTable()) {
 $this->jointable = sqlf_table($this->jointable);
 $this->joincol = sqlf_field($this->joincol);
 $this->jointablecol = sqlf_field($this->jointablecol);
 }

 
 if ($this->hasJoinTable()) {
 $sql = "SELECT ".$this->table."_nodeversion.id FROM ".$this->table."_nodeversion, ".$this->jointable.
 " WHERE ".$this->table."_nodeversion.".$this->joincol." = ".$this->jointablecol.
 " AND ".$this->table."_nodeversion.nodeversionlatest = 1 AND " .$this->where;
 } else {
 $sql = "SELECT ".$this->table."_nodeversion.id FROM ".$this->table."_nodeversion, ".$this->table.
 " WHERE ".$this->table."_nodeversion.id = ".$this->table.".id".
 " AND ".$this->table."_nodeversion.nodeversionlatest = 1 AND " .$this->where;
 }
 $rs = query($sql);
 $lastversion = $rs["arr"];

 
 if ($this->hasJoinTable()) {
 $sql = "SELECT ".$this->table.".id FROM ".$this->table.", ".$this->jointable.
 " WHERE ".$this->table.".".$this->joincol." = ".$this->jointablecol." AND ".$this->where;
 } else {
 $sql = "SELECT ".$this->table.".id FROM ".$this->table.
 " WHERE ".$this->where;
 }
 $rs = query($sql);
 $currentversion = $rs["arr"];

 
 if ($this->hasJoinTable()) {
 $sql = "SELECT ".$this->table.".* FROM ".$this->jointable." LEFT JOIN ".$this->table." ".
 " ON (".$this->jointablecol." = ".$this->table.".".$this->joincol.")".
 " LEFT JOIN ".$this->table."_nodeversion ON (".$this->jointablecol." = ".$this->table."_nodeversion.".$this->joincol.
 " AND ".$this->table.".id = ".$this->table."_nodeversion.id AND ".$this->table."_nodeversion.nodeversionlatest = 1)".
 " WHERE ".$this->where." AND ".$this->table.".".$this->joincol." IS NOT NULL ".
 " AND ((".$this->table."_nodeversion.nodeversionlatest = 1 AND (1=2";
 } else {
 $sql = "SELECT ".$this->table.".* FROM ".$this->table.
 " LEFT JOIN ".$this->table."_nodeversion ON (".$this->table.".id = ".$this->table."_nodeversion.id AND ".$this->table."_nodeversion.nodeversionlatest = 1)".
 " WHERE ".$this->where.
 " AND ((".$this->table."_nodeversion.nodeversionlatest = 1 AND (1=2";
 }
 while (list($colname,$col) = each($tablecols)) {
 $sql .= " OR ".$this->table.".".sqlf_field($colname)." != ".$this->table."_nodeversion.".sqlf_field($colname);
 }
 $sql .= ")) OR ".$this->table."_nodeversion.nodeversiontimestamp IS NULL)";
 $rs = query($sql);

 
 if ($rs["num"] > 0) $newversion = true;
 

 $ids = Array();
 $ids[] = 0;

 
 foreach($rs["arr"] as $row) {

 if (!$row["id"]) continue;
 
 reset($tablecols);
 $columns = Array();
 $values = Array();
 while (list($colname,$col) = each($tablecols)) {
 $columns[] = $colname;
 $values[] = "'".sqlslashes($row[$colname])."'";
 }
 $ids[] = $row["id"];
 
 $sql = "UPDATE ".sqlf_table($this->table)."_nodeversion SET nodeversionlatest = 0 WHERE id = ".sqlf_tl_num($row["id"]);
 if (!$fake) query($sql);
 
 $sql = "INSERT INTO ".sqlf_table($this->table)."_nodeversion (".implode(",",sqlf_field_array($columns)).",nodeversiontimestamp,nodeversionlatest,nodeversion_user)".
 " VALUES (".implode(",",$values).",".sqlf_tl_num($time).",1,".sqlf_tl_num($user).")";
 if (!$fake) query($sql);
 }

 if (count($lastversion) > 0) {
 
 $lastids = Array();
 $lastids[] = 0;
 foreach($lastversion as $lastrow) {
 $lastids[] = $lastrow["id"];
 }

 
 $currentids = Array();
 $currentids[] = 0;
 foreach($currentversion as $currentrow) {
 $currentids[] = $currentrow["id"];
 }

 
 if (!$fake) {
 $sql = "UPDATE ".sqlf_table($this->table)."_nodeversion SET nodeversionremoved = ".sqlf_tl_num($time).", nodeversionlatest = 0".
 " WHERE id IN (".implode(",",sqlf_tl_num_array($lastids)).") AND id NOT IN (".implode(",",sqlf_tl_num_array($currentids)).")";
 $rs = query($sql);
 } else {
 $sql = "SELECT id FROM ".sqlf_table($this->table)."_nodeversion ".
 "WHERE id IN (".implode(",",sqlf_tl_num_array($lastids)).") AND id NOT IN (".implode(",",sqlf_tl_num_array($currentids)).")";
 $rs = query($sql);
 }

 
 if ($rs["num"] > 0) $newversion = true;
 }

 return $newversion;

 }

 function restoreVersion($time) {
 
 $tablecols = $this->getVersionedColumns();
 $nonVersionedCols = $this->getNonVersionedColumns();
 $this->table = sqlf_table($this->table);
 if ($this->hasJoinTable()) {
 $this->jointable = sqlf_table($this->jointable);
 $this->joincol = sqlf_field($this->joincol);
 $this->jointablecol = sqlf_field($this->jointablecol);
 }

 
 if ($this->hasJoinTable()) {
 $sql = "SELECT ".$this->table."_nodeversion.id, max(".$this->table."_nodeversion.nodeversiontimestamp) AS nodeversionrtime".
 " FROM ".$this->table."_nodeversion, ".$this->jointable.
 " WHERE ".$this->table."_nodeversion.".$this->joincol." = ".$this->jointablecol.
 " AND (nodeversionremoved > ".sqlf_tl_num($time)." OR nodeversionremoved = 0) AND nodeversiontimestamp <= ".sqlf_tl_num($time)." ".
 " AND ".$this->where." GROUP BY id";
 } else {
 $sql = "SELECT ".$this->table."_nodeversion.id, max(".$this->table."_nodeversion.nodeversiontimestamp) AS nodeversionrtime".
 " FROM ".$this->table."_nodeversion LEFT JOIN ".$this->table." USING(id)".
 " WHERE (nodeversionremoved > ".sqlf_tl_num($time)." OR nodeversionremoved = 0) AND nodeversiontimestamp <= ".sqlf_tl_num($time)." ".
 " AND ".$this->where." GROUP BY ".$this->table."_nodeversion.id";
 }
 decho ( "Restore-SQL: ".$sql."<br>", "version" );
 $rs = query($sql);

 $rowsToRestore = array();
 foreach($rs["arr"] as $row) {

 
 
 
 $sql = "SELECT DISTINCT " . implode(",", sqlf_field_array(array_keys($tablecols))) . " FROM ".$this->table."_nodeversion ".
 " WHERE id = ".sqlf_tl_num($row["id"])." AND nodeversiontimestamp = ".sqlf_tl_num($row["nodeversionrtime"]);
 $rs2 = query($sql);

 if ($rs2["num"] == 0) {
 
 
 halt(101,"restoreVersion: version not found  (".$this->table.",".$row["id"].",".$row["nodeversionrtime"].": ".$rs2["num"]); 
 }
 elseif ($rs2["num"] != 1) {
 
 
 
 global $NODEVERSION_DISCRIMINATOR;
 if (isset($NODEVERSION_DISCRIMINATOR)) {
 $rs2["arr"][0] = $rs2["arr"][$NODEVERSION_DISCRIMINATOR];
 }
 }

 reset($tablecols);
 $columns = Array();
 $values = Array();
 while (list($colname,$col) = each($tablecols)) {
 $columns[] = $colname;
 $values[] = "'".sqlslashes($rs2["arr"][0][$colname])."'";
 }

 $currentValues = $this->getCurrentValues($row["id"], $nonVersionedColumns);
 $columns = array_merge($columns, array_keys($currentValues));
 $values = array_merge($values, array_values($currentValues));
 $rowsToRestore[] = array_combine($columns, $values);
 }

 
 
 if ($this->hasJoinTable()) {
 $sql = "DELETE ".$this->table." FROM ".$this->table.", ".$this->jointable.
 " WHERE ".$this->table.".".$this->joincol." = ".$this->jointablecol.
 " AND ".$this->where;
 } else {
 $sql = "DELETE FROM " . $this->table . " WHERE " . $this->where;
 }
 decho ( "Restore-SQL: deleting old entries: $sql");
 query($sql);

 foreach ($rowsToRestore as $row) {
 $columns = array_keys($row);
 $values = array_values($row);
 
 $sql = "INSERT INTO ".$this->table." (".implode(",",sqlf_field_array($columns)).") VALUES (".implode(",",$values).")";
 query($sql);
 }
 }

 
 
 function deleteOldVersions($time) {
 $this->table = sqlf_table($this->table);

 if ($time > 0) {
 while(true) {
 set_time_limit(30);
 $sql = "SELECT id, MAX(nodeversiontimestamp) t FROM ".$this->table."_nodeversion ".
 "WHERE nodeversiontimestamp < ".sqlf_tl_num($time)." GROUP BY id LIMIT 1000";
 $rs = query($sql);
 if( $rs['num'] == 0 ) {
 break;
 }
 $idlist = array();
 foreach ($rs["arr"] as $row) {
 $sql = "UPDATE ".$this->table."_nodeversion SET nodeversiontimestamp = ".sqlf_tl_num($time)." ".
 "WHERE id = ".sqlf_tl_num($row["id"])." AND nodeversiontimestamp = ".sqlf_tl_num($row["t"]);
 query($sql);
 $idlist[] = $row["id"];
 }
 $sql = "DELETE FROM ".$this->table."_nodeversion WHERE nodeversiontimestamp < ".sqlf_tl_num($time)." AND id IN (".implode(",", sqlf_tl_num_array($idlist)).")";
 query($sql);
 decho ( "Delete-SQL: ".$sql."<br>", "version");
 }
 } else {
 decho ("Skipping deletion, invalid time($time)" );
 }
 } 

 
 function deleteAllVersions( ) {
 $this->table = sqlf_table($this->table);
 if ($this->hasJoinTable()) {
 $this->jointable = sqlf_table($this->jointable);
 $this->joincol = sqlf_field($this->joincol);
 $this->jointablecol = sqlf_field($this->jointablecol);
 }

 if ($this->hasJoinTable()) {
 $sql = "DELETE ".$this->table."_nodeversion FROM ".$this->table."_nodeversion, ".$this->jointable.
 " WHERE ".$this->table."_nodeversion.".$this->joincol." = ".$this->jointablecol.
 " AND ".$this->where;
 } else {
 $sql = "DELETE ".$this->table."_nodeversion FROM ".$this->table."_nodeversion, ".$this->table.
 " WHERE ".$this->table."_nodeversion.id = ".$this->table.".id AND ".$this->where;
 }
 decho ( "Delete-SQL: ".$sql."<br>", "version" );
 query( $sql );
 }

 function getVersions($time = 0) {
 $this->table = sqlf_table($this->table);
 if ($this->hasJoinTable()) {
 $this->jointable = sqlf_table($this->jointable);
 $this->joincol = sqlf_field($this->joincol);
 $this->jointablecol = sqlf_field($this->jointablecol);
 }

 
 if ($this->hasJoinTable()) {
 $sql = "SELECT ".$this->table."_nodeversion.nodeversiontimestamp AS timestamp, ".$this->table."_nodeversion.nodeversion_user AS user_id".
 " FROM ".$this->table."_nodeversion, ".$this->jointable.
 " WHERE ".$this->table."_nodeversion.".$this->joincol." = ".$this->jointablecol.
 " GROUP BY ".$this->table."_nodeversion.nodeversiontimestamp, ".$this->table."_nodeversion.nodeversion_user ".
 " ORDER BY ".$this->table."_nodeversion.nodeversiontimestamp";
 } else {
 $sql = "SELECT ".$this->table."_nodeversion.nodeversiontimestamp AS timestamp, ".$this->table."_nodeversion.nodeversion_user AS user_id".
 " FROM ".$this->table."_nodeversion".
 " GROUP BY ".$this->table."_nodeversion.nodeversiontimestamp, ".$this->table."_nodeversion.nodeversion_user ".
 " ORDER BY ".$this->table."_nodeversion.nodeversiontimestamp";
 }

 $rs = query($sql);

 return $rs["arr"];

 }

 



 function hasJoinTable() {
 return $this->jointable && $this->joincol && $this->jointablecol;
 }

 




 function getVersionedColumns() {
 $origcols = mydb_desc_table($this->table, false, true);
 $versioncols = mydb_desc_table($this->table."_nodeversion", false, true);
 return array_intersect_assoc($origcols, $versioncols);
 }

 









 function getNonVersionedColumns() {
 $cols = mydb_desc_table($this->table, false, true);
 $versionedCols = $this->getVersionedColumns();
 return array_diff_key($cols, $versionedCols);
 }

 










 function getCurrentValues($id, $columns) {
 if (empty($columns)) {
 return array();
 }
 $sql = "SELECT " . implode(",", sqlf_name_array($columns))
 . " FROM " . sql_name($this->table)
 . " WHERE id = " . sql_num($id);
 $rs = query($sql);
 if (count($rs["arr"]) == 0) {
 halt(7, "Versioned table " . $this->table
 . " doesn't have a current entry (" . $sql . ")");
 }
 if (count($rs["arr"]) > 1) {
 warning(7, "Versioned table " . $this->table
 . " has more than one entry (" . $sql . ")");
 }
 
 return array_intersect_key($rs["arr"][0], array_fill_keys($columns, true));
 }
}
?>
