<?php

class ItemListActionDataSource extends FormattedDataSource
{
 var $d_actions = array();
 var $d_actionList = array();
 var $d_singleActions = array();
 var $d_defaultAction = null;
 var $d_destructiveActions = array();
 
 

















 function addSingleAction( &$itemListAction, $key, &$comparator )
 {
 if ( !is_subclass_of( $itemListAction, "ItemListAction" ) )
 halt( 7, "Not a subclass of ItemListAction" );
 $this->d_singleActions[] = Array( "id"=>$id, "action"=>&$itemListAction, "key"=>$key,
 "comparator"=>$comparator );
 $cmd = $itemListAction->getCommandName();
 $this->d_actions[$cmd][] = &$itemListAction;
 }
 
 function getSingleActions( $rsKey, $rowData )
 {
 $ret = array();
 
 foreach ( $this->d_singleActions as $action )
 {
 
 if ( $action["comparator"]->compareTo( $rowData[$action["key"]] ) == 0 )
 {
 $cmd = $action["action"]->getCommandName();
 
 
 if ( !isset( $ret[$cmd] ) )
 $ret[$cmd] = $action["action"]->getDescription();
 }
 }
 
 return $ret;
 }

 function getAllSingleActions( ) {
 $ret = array();
 foreach ( $this->d_singleActions as $action ) {
 $cmd = $action['action']->getCommandName();
 if ( !isset( $ret[$cmd] ) )
 $ret[$cmd] = $action["action"]->getDescription();
 }
 return $ret;
 }
 
 
 function performSingleAction( $action, $ids )
 {
 return $this->performAction( $action, array($ids) );
 }

 










 function addAction( &$itemListAction )
 {
 if ( !is_subclass_of( $itemListAction, "ItemListAction" ) )
 halt( 7, "Not a subclass of ItemListAction" );
 $cmd = $itemListAction->getCommandName();
 $this->d_actions[$cmd][] = &$itemListAction;
 if ( !$this->d_actionList[$cmd] )
 {
 $this->d_actionList[$cmd] = array( 
 "desc" => $itemListAction->getDescription(),
 "js" => $itemListAction->getJSAction() );
 }
 }
 
 function setAction( &$itemListAction )
 {
 $cmd = $itemListAction->getCommandName();
 $this->d_actions[$cmd] = array();
 $this->d_actions[$cmd][] = &$itemListAction;
 $this->d_actionList[$cmd] = array( 
 "desc" => $itemListAction->getDescription(),
 "js" => $itemListAction->getJSAction() );
 }

 





 function setDefaultAction( &$action )
 {
 if ( !is_subclass_of( $action, "ItemListAction" ) )
 halt( 7, "Not a subclass of ItemListAction" );
 $this->d_defaultAction = &$action;
 }

 




 function getDefaultAction()
 {
 if ( null !== $this->d_defaultAction )
 return $this->d_defaultAction->getCommandName();
 }

 










 function getActions() 
 { 
 return $this->d_actionList;
 }
 
 





 function getActionIcon( $action ) 
 { 
 if ( is_array( $this->d_actions[$action] ) )
 return $this->d_actions[$action][0]->getIconTag();
 return null;
 }
 
 
 









 function performAction( $action, $ids ) 
 {
 if ( is_array($this->d_actions[$action]) )
 {
 foreach ( $this->d_actions[$action] as $key=>$handler )
 {
 $res = $handler->performAction( $ids, $this );
 if ( $res )
 return $res;
 }
 }
 else if ( null !== $this->d_defaultAction )
 {
 if ( $this->d_defaultAction->getCommandName() === $action )
 {
 $this->d_defaultAction->performAction($ids, $this);
 }
 }
 return null;
 }

 


 function setDestructiveActions($actions) {
 $this->d_destructiveActions = $actions;
 }

 


 function isDestructiveAction($action) {
 $destructive = $this->d_destructiveActions[$action];
 return is_null($destructive) || (bool)$destructive;
 }
}

?>
