<?php







class ComponentChooser extends CollectionComponent
{
 function ComponentChooser( $label=NULL, $preSelected=FALSE )
 {
 parent::CollectionComponent( $label );
 if ( strlen($preSelected) != 0 ) $this->setSelection( $preSelected );
 }

 function onLoadFinished(&$form)
 {
 parent::onLoadFinished(&$form);
 if ( !$this->isOptional() )
 {
 $sel = $this->getSelection();
 if ( strlen($sel) == 0 ) {
 $this->setFieldError( "__s", new NodeException( i18n( "An element must be selected!" ) ) );
 }
 }
 }
 
 function setSelection( $sel )
 {
 $this->d_values["__s"] = $sel;
 }
 
 function getSelection()
 {
 return $this->d_values["__s"];
 }
 
 function &getSelectedComponent()
 {
 return $this->getComponent( $this->getSelection() );
 }
 
 function getFocusableElementName()
 {
 $cName = $this->getSelection();
 $ele =& $this->getComponent( $cName );
 if ( !is_a( $ele, "formcomponent" ) ) return NULL;
 $name = $ele->getFocusableElementName();
 if ( $name ) return $cName . $name;
 return NULL;
 }

 function getFields()
 {
 $fields = parent::getFields();
 $fields["__s"] = "Component Selector";
 return $fields;
 }

 function getHTML( &$form, $fieldPrefix, $doCheck, $checkSeverity, $key ) {
 $onchange = "onchange=\"".$enablerJs. "\"";
 $strStyle = $this->_translateStyle( $doCheck, $checkSeverity );
 $optional = $this->isOptional()?"true":"false";
 $formName = $form->getFormName();
 $eMsg = i18n( "An element must be selected!" );
 $form->addJsCheck( "checkRadio( '$formName', '${fieldPrefix}__s', ".
 " '$eMsg', $optional, focusOnError )" );
 
 $opts = &$this->iterator();
 $sel = $this->getSelection();
 $name = "${fieldPrefix}__s";
 $i=0;
 
 $html = "<table border=0>";
 while ( $opts->hasNext() )
 {
 unset( $ele ); $ele = &$opts->next();
 $key = $opts->getKey();

 $eHtml = $this->_getComponentHTMLTable( $key, $form, $fieldPrefix, $doCheck, $checkSeverity, $key, TRUE ); 
 $selected = ("$sel"=="$key")?"CHECKED":"";
 $html .= "<tr><td><input type=radio name=$name id=$name$i $selected $onchange style=\"$strStyle\" value=\"$key\"></td>\n";
 $html .= "<td><label for=$name$i>".$eHtml."</label></td></tr>\n";
 $i++;
 }
 $html .= "</table>";
 return $this->mergeResult( parent::getHTML( $form, $fieldPrefix, $doCheck, $checkSeverity, $key ), $html );
 }
 
}

?>
