<?php

class WizardBuilder extends BaseObject
{
 function updateStep( &$wizard, $stepNr, &$form ) {}
 function createStep( &$wizard, $stepNr, &$form ) {}

 


 function prepareStep( &$wizard, $stepNr, &$form) {}
 function done( &$wizard ) {}
 function cancel( &$wizard ) {}
 function getAdditionalButtons( &$wizard ) { return array(); }
 function handleButton( &$wizard, $btnType, $btnKey ) { return true; }

 function getDoneLabel() { return i18n( "Done" ); }
}

class HtmlFormWizard extends BaseObject
{
 var $m_name;
 var $m_builder = FALSE;
 var $m_isDone = FALSE;
 var $m_isCanceled = FALSE;
 var $m_isNew = TRUE;
 var $m_stepId = -1;
 var $m_lastStepId;
 var $m_stepCount;
 var $m_isLastStep = FALSE;
 var $m_steps = array();
 var $m_uniqueId = -1;
 var $m_title = "";
 var $m_icon = "";
 var $m_nestedForm = FALSE;
 var $m_buttonsInvisible = array();
 var $m_btnParams = FALSE;
 var $m_hideButtons = array();

 







 function HtmlFormWizard( $name )
 {
 $this->m_name = $name;
 $this->_restore();
 }

 




 function getStepId() {
 return $this->m_stepId;
 }
 
 function setNestedForm( $name )
 {
 $this->m_nestedForm = $name;
 foreach ( $this->m_steps as $stepId=>$step )
 {
 $this->m_steps[$stepId]->setNestedForm( $name );
 }
 }
 
 function setBuilder( &$wizardBuilder, $stepCount=0 )
 {
 $this->m_builder = &$wizardBuilder;
 $this->m_stepCount = $stepCount;
 }
 
 function &getBuilder()
 {
 return $this->m_builder;
 }
 
 function _storeToSession()
 {
 unset( $this->m_steps[$this->m_stepId] );
 $sSteps = array();
 foreach ( $this->m_steps as $stepId=>$step )
 {
 $sSteps[$stepId] = node_serialize( $step );
 }
 $rs = array(
 "steps" => $sSteps,
 "stepId" => $this->m_stepId,
 "title" => $this->m_title,
 "icon" => $this->m_icon,
 "isLastStep" => $this->m_isLastStep,
 "builder" => node_serialize( $this->m_builder ),
 "nested" => $this->m_nestedForm,
 "buttonsinvisible" => $this->m_buttonsInvisible,
 "stepcount" => $this->m_stepCount,
 "hidebuttons" => $this->m_hideButtons
 );
 mysession_updateUnique( $this->m_uniqueId, $rs );
 }

 function _restoreFromSession( $id, $isError )
 {
 $this->m_uniqueId = $id;
 $rs = mysession_loadUnique( $id, TRUE );
 $this->m_steps = array();
 foreach ( $rs["steps"] as $stepId=>$sStep )
 {
 $this->m_steps[$stepId] = &node_unserialize( $sStep );
 }
 $this->m_lastStepId = $rs["stepId"];
 $this->m_title = $rs["title"];
 $this->m_icon = $rs["icon"];
 $this->m_builder = &node_unserialize( $rs["builder"] );
 $this->m_isLastStep = $rs["isLastStep"];
 $this->m_nestedForm = $rs["nested"];
 $this->m_buttonsInvisible = $rs["buttonsinvisible"];
 $this->m_stepCount = $rs["stepcount"];
 $this->m_hideButtons = $rs["hidebuttons"];
 }
 
 function _restore()
 {
 $form =& new HtmlForm3R( "wiz$this->m_name", $this );
 if ( $form->isNew() )
 {
 if ( $this->m_nestedForm )
 $form->setNestedForm( $this->m_nestedForm ); 
 $this->m_isNew = TRUE;
 $this->m_stepId = 1;
 $this->m_uniqueId = mysession_createUnique();
 }
 else
 {
 $this->m_isNew = FALSE;
 $comp = &$form->getComponent( "hidden" );
 $hidden = $comp->getValue();
 $this->_restoreFromSession( $hidden["id"], $form->isError() );
 
 $this->m_steps[$this->m_lastStepId] = &$form;
 if ( $this->m_stepId < 0 ) $this->m_stepId = $this->m_lastStepId;
 if ( $this->isDone() ) $this->m_builder->done( $this );
 if ( $this->isCanceled() ) $this->m_builder->cancel( $this );
 if ( is_array($this->m_btnParams) ) {
 $this->m_builder->handleButton( $this, $this->m_btnParams["type"], $this->m_btnParams["key"] );
 $this->m_btnParams = false;
 }
 }
 if ( $this->m_stepCount > 0 && $this->m_stepId == $this->m_stepCount )
 $this->m_isLastStep = $this->m_stepId;
 }

 function _addButtons( &$form )
 {
 if ( !$this->m_buttonsInvisible[$this->m_stepId] ) 
 {
 $btns = $this->m_builder->getAdditionalButtons( $this );

 $form->addButton( "cancel", new Button( i18n( "Cancel" ), FALSE ), new SimpleResolvableFormAction( "cancel" ) );
 if ( $this->m_stepId > 1 )
 $form->addButton( "back", new Button( i18n( "Back" ), FALSE ), new SimpleResolvableFormAction( "back", $this->m_stepId ) );
 if ( $this->m_isLastStep != $this->m_stepId )
 $form->addButton( "next", new Button( i18n( "Next" ) ), new SimpleResolvableFormAction( "next", $this->m_stepId ), TRUE );
 else {
 $form->addButton( "next", new Button( $this->m_builder->getDoneLabel( ) ), new SimpleResolvableFormAction( "done", $this->m_stepId ), TRUE );
 if (is_array($btns["done"])) {
 foreach ($btns["done"] as $btn) {
 $btnKey = $btn["key"];
 $btnName = $btn["name"];
 $form->addButton( "done_$btnKey", new Button( $btnName ), new SimpleResolvableFormAction( "btns", 
 array("step"=>$this->m_stepId, "type"=>"done", "key"=>$btnKey) ), TRUE );
 }
 }
 }
 }
 else
 {
 $form->removeButton( "cancel" );
 $form->removeButton( "back" );
 $form->removeButton( "next" );
 }

 if ( $this->_isHiddenButton("cancel") ) {
 $form->removeButton("cancel");
 }
 if ( $this->_isHiddenButton("back") ) {
 $form->removeButton("back");
 }
 if ( $this->_isHiddenButton("next") ) {
 $form->removeButton("next");
 }
 }
 
 function& _createStep()
 {
 if ( !is_object($this->m_builder) )
 halt( 101, "HtmlformWizard: Please set a builder with ->setBuilder()" );
 $this->m_builder->prepareStep( $this, $this->m_stepId, $this->m_steps[$this->m_stepId] );
 if ( isset( $this->m_steps[$this->m_stepId] ) || $this->m_stepId == $this->m_lastStepId )
 {
 $this->m_builder->updateStep( $this, $this->m_stepId, $this->m_steps[$this->m_stepId] );
 
 $this->_addButtons($this->m_steps[$this->m_stepId]);
 }
 else
 {
 if ( $this->m_stepCount > 0 )
 $stepTxt = " (".i18n( "Step {0}/{1}", 0, $this->m_stepId, $this->m_stepCount ).")";
 
 
 
 $form = new HtmlForm3R( "wiz$this->m_name", $this, FALSE );
 if ( $this->m_nestedForm )
 $form->setNestedForm( $this->m_nestedForm ); 
 $form->setHeader( $this->m_title . $stepTxt, $this->m_icon );
 
 $this->m_steps[$this->m_stepId] = &$form;
 $this->m_builder->createStep( $this, $this->m_stepId, $this->m_steps[$this->m_stepId] );
 $form->addComponent( "hidden", new HiddenComponent( array( "id"=>$this->m_uniqueId ) ) );
 $this->_addButtons($this->m_steps[$this->m_stepId]);
 }
 return $this->m_steps[$this->m_stepId];
 }
 
 function isDone()
 {
 return $this->m_isDone;
 }
 
 function isCanceled() 
 {
 return $this->m_isCanceled;
 }
 
 function isNew()
 {
 return $this->m_isNew;
 }
 
 function lastStep()
 {
 $this->m_isLastStep = $this->m_stepId;
 }
 
 function setButtonsVisibility( $isVisible )
 {
 $this->m_buttonsInvisible[$this->m_stepId] = !$isVisible;
 }
 
 function done()
 {
 $this->m_isDone = TRUE;
 $this->m_builder->done( $this );
 }
 
 function setHeader( $title, $icon=NULL )
 {
 $this->m_title = $title;
 $this->m_icon = $icon;
 }
 
 function &getStep( $stepNr )
 {
 return $this->m_steps[$stepNr];
 }
 
 function resolveAction( &$form, &$action, $param )
 {
 $name = $action->getName();
 switch ( $name )
 {
 case "next":
 $this->m_stepId = $action->getParam() + 1;
 break;
 case "back":
 $this->m_stepId = $action->getParam() - 1;
 break;
 case "cancel":
 $this->m_isCanceled = true;
 break;
 case "done":
 $this->m_isDone = true;
 break;
 case "btns":
 $params = $action->getParam();
 $this->m_btnParams = $params;
 
 if ($params["type"] == "done") {
 $this->m_isDone = true;
 } else if ($params["type"] == "cancel") {
 $this->m_isCanceled = true;
 } else if ($params["type"] == "next") {
 $this->m_stepId = $params["step"] + 1;
 } else if ($params["type"] == "back") {
 $this->m_stepId = $params["step"] - 1;
 }
 
 break;
 }
 }
 
 function getHtmlOutput()
 {
 if ( !$this->isDone() && !$this->isCanceled() )
 {
 $form =& $this->_createStep();
 $ret = $form->getHtmlOutput();
 }
 $this->_storeToSession();
 return $ret;
 }

 function setButtonVisibility($button, $visible) {
 $buttons = null;
 if ($this->m_hideButtons[$this->m_stepId]) {
 $buttons = $this->m_hideButtons[$this->m_stepId];
 } else {
 $buttons = array();
 }
 $buttons[$button] = !$visible;
 $this->m_hideButtons[$this->m_stepId] = $buttons;
 }

 function _isHiddenButton($button) {
 if (! $this->m_hideButtons[$this->m_stepId]) {
 return false;
 }
 if ($this->m_hideButtons[$this->m_stepId][$button]) {
 return true;
 }
 return false;
 }
}

?>
